<%@ Assembly Name="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Page Language="C#" Inherits="Microsoft.SharePoint.WebPartPages.WikiEditPage" MasterPageFile="~masterurl/default.master" %>
<%@ Register TagPrefix="SharePoint" Namespace="Microsoft.SharePoint.WebControls" Assembly="Microsoft.SharePoint, Version=14.0.0.0, Culture=neutral, PublicKeyToken=71e9bce111e9429c" %>
<%@ Import Namespace="Microsoft.SharePoint" %>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitle' runat='server'>
        Proxy Client Test Page
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderPageTitleInTitleArea' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderAdditionalPageHead' runat='server'>
    <script   src="https://code.jquery.com/jquery-1.12.4.js"   integrity="sha256-Qw82+bXyGq6MydymqBxNPYTaUXXq7c8v3CwiYwLLNXU="   crossorigin="anonymous"></script>
    <!--
    @copyright 2018 Joe McShea
    @license under the MIT license:
        http://www.opensource.org/licenses/mit-license.php
    -->
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderMiniConsole' runat='server'>
</asp:Content>
<asp:Content ContentPlaceHolderID='PlaceHolderLeftActions' runat='server'>
</asp:Content>
<asp:content contentplaceholderid="PlaceHolderMain" runat="server">

    <h1>Proxy Client Test Page</h1>
    <!-- button to test the service call through CORS -->
    <input type="button" name="btnTest" id="btnTest" value="Test CORS Proxy"><br>
    <!-- iframe to load the service proxy -->
    <iframe id="spproxy" src="https://speasyforms.wingtip.com/Style%20Library/proxy.aspx" height="0" width="0">
    </iframe>
    <script type="text/javascript">
        // change these to match your environment, the iframe source origin 
        // (meaning the fully qualified host name if you skipped ahead) should 
        // be the same as the expectedOrigin
        var expectedOrigin = "https://speasyforms.wingtip.com";
        var listTitle = "Announcements";

        // add an event handler for postMessages received
        $(window).on("message", function(e) {
            try {
                // parse the json result and popup in an alert
                alert(JSON.parse(e.originalEvent.data, null, 4));
            }
            catch(e) { alert(JSON.parse(e, null, 4)); }
        });

        // send a message to the iframe with the Ajax options
        function callRestApiThroughPostMessage(options) {
            $("#spproxy")[0].contentWindow.postMessage(
                JSON.stringify(options, expectedOrigin),
                expectedOrigin);
        }

        // call the REST service indirectly through post message
        $("#btnTest").click(function() {
            callRestApiThroughPostMessage({
                url: "~site/_api/web/lists/getbytitle('Announcements')",
                type: "GET",
                contentType: "application/json;odata=verbose",
                headers: {
                    "Accept": "application/json;odata=verbose"
                }                
            });
        });
    </script>

</asp:content>